import numpy as np

P = np.zeros((10, 10))

# Transition probabilities for state 0.
P[0, 0] = 3 / 4
P[0, 1] = 1 / 4
# Transition probabilities for state 9
P[9, 9] = 3 / 4
P[9, 8] = 1 / 4
# Transition probabilities for state 0<i<9.
for i in range(1, 9):
    P[i, i - 1] = 1 / 4
    P[i, i] = 1 / 2
    P[i, i + 1] = 1 / 4

# Sanity check for rows to sum to 1.
assert np.allclose(P @ np.ones(10), np.ones(10))

# Solve these equations simultaneously
A = np.concatenate([(P - np.eye(10)).T, np.ones((1, 10))])
pi = np.linalg.lstsq(A, np.concatenate([np.zeros(10), [1]]))[0]
print(f'The stationary distribution is : {pi}')

# Expected output: [0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1 0.1]