def generate_matrix(N, r, d):
    P = np.zeros((N + 1, N + 1))
    for x in range(N):
        binom_param = 1 / d
        poisson_param = r * x / d
        for y in range(N):
            # Evaluate P(X_{n+1} = y | X_n = x).
            prob = 0
            for k in range(max(y - x, 0), x + 1):
                prob += scipy.stats.binom.pmf(k=k, n=x, p=binom_param) * \
                        scipy.stats.poisson.pmf(k=y - (x - k), mu=poisson_param)
            P[x, y] = prob
    # Set the absorbing state.
    P[:N, N] = 1 - np.sum(P[:N, :N], axis=1)
    P[N, N] = 1
    return P
